/*
 * test.c:
 *
 * Copyright (c) 2001 Chris Lightfoot. All rights reserved.
 * Email: chris@ex-parrot.com; WWW: http://www.ex-parrot.com/~chris/
 *
 */

static const char rcsid[] = "$Id:$";

#include <stdio.h>

#include "img.h"

int main(int argc, char **argv) {
    img I, dest;
    FILE *fp;
    int i;
    char *imgs[] = {"a.gif", "b.gif", "c.gif", "d.gif"};
    pel *p, *q, *end;
    
    dest = img_new_blank(400, 400);
    img_alloc(dest);
    
    for (i = 0; i < 4; ++i) {
        int x, y;
        int xo = i & 1 ? 200 : 0;
        int yo = i & 2 ? 200 : 0;

        I = img_new();
        if (!img_load_file(I, imgs[i], header, unknown)) {
            printf("load hdr err = %d\n", I->err);
            return -1;
        }

        printf("w = %d h = %d type = %d\n", I->width, I->height, I->type);

        if (!img_load(I, full, I->type)) {
            printf("load img err = %d\n", I->err);
            return -1;
        }

        /* copy data into right place. */
        for (y = 0; y < 200; ++y) for (x = 0; x < 200; ++x) {
            dest->data[y + yo][x + xo] = I->data[y][x];
        }

        if (i != 3) img_delete(I);
    }

    for (p = I->flat, end = p + I->width * I->height, q = dest->flat, i = 0;
         p < end; ++p, q += 2, ++i) {
        int r, g, b;
        r = GETR(*q) + GETR(*(q + 1)) + GETR(*(q + dest->width)) + GETR(*(q + dest->width + 1));
        g = GETG(*q) + GETG(*(q + 1)) + GETG(*(q + dest->width)) + GETG(*(q + dest->width + 1));
        b = GETB(*q) + GETB(*(q + 1)) + GETB(*(q + dest->width)) + GETB(*(q + dest->width + 1));
        *p = PEL(r / 4, g / 4, b / 4);
        if (i == I->width) {
            i = 0;
            q += dest->width;
        }
    }

    fp = fopen("foo.jpg", "wb");
    if (!img_save(I, fp, jpeg)) {
        printf("jpg save img err = %d\n", I->err);
        return -1;
    }
    fclose(fp);

    img_delete(dest);
    
    return 0;
}
